#include	<stdio.h>
#include	<dir.h>

#define     OK      0
#define 	ERROR	(-1)

int popstr( char *filename, int nstr, char *str ) {
/*
	return the first line of a stack file to the caller,
	removing the line from the file in the process.
 */
	FILE *stkfp;
	FILE *oldstk;
    int  stat;
	char pathbuf[MAXPATH];
	char drvbuf[MAXDRIVE];
	char dirbuf[MAXDIR];
	char nambuf[MAXFILE];
	char extbuf[MAXEXT];
	char *tmpbuf = ".TMP";
    int  fnflags;
	register int c;

    fnflags = fnsplit( filename, drvbuf, dirbuf, nambuf, extbuf );
    fnmerge( pathbuf, drvbuf, dirbuf, nambuf, tmpbuf );
    if(( oldstk = fopen( filename, "r" )) == NULL ) {
        puts( "PopStr: NO Directories on stack." );
		return ERROR;
    }
    if( fgets( str, nstr, oldstk ) == NULL ) {
        puts( "PopStr: NO Directories on stack." );
        fclose( oldstk );
		return ERROR;
    }
    str[strlen( str )-1] = '\0';
    if(( stkfp = fopen( pathbuf, "w" )) == NULL ) {
        puts( "PopStr: Can't open new stack file." );
        fclose( oldstk );
		return ERROR;
    }
    while(( c = getc( oldstk )) != EOF )
        putc( c, stkfp );
    fclose( oldstk );
    fclose( stkfp );
    unlink( filename );
    if(( stat = rename( pathbuf, filename )) != 0 ) {
        puts( "PopStr: Trouble renaming file." );
		return ERROR;
    }
	return OK;
}
