#include	<stdio.h>
#include	<dir.h>

#define     OK      0
#define		ERROR	(-1)

int pushstr(char *filename, char *str) {
/*
	Prepend a line to a stack file.
 */
	FILE *stkfp;
	FILE *oldstk;
    int  stat;
	char pathbuf[MAXPATH];
	char drvbuf[MAXDRIVE];
	char dirbuf[MAXDIR];
	char nambuf[MAXFILE];
	char extbuf[MAXEXT];
	char *tmpbuf = ".TMP";
    int  fnflags;
	register int c;

    fnflags = fnsplit( filename, drvbuf, dirbuf, nambuf, extbuf );
    fnmerge( pathbuf, drvbuf, dirbuf, nambuf, tmpbuf );
    if(( stkfp=fopen( pathbuf, "w" )) == NULL ) {
        puts( "PushStr: Can't open stack file." );
		return ERROR;
    }
    fputs( str, stkfp );
    fputc( '\n', stkfp );
/*
    Now, copy the old stack file onto the end of the new one.
 */
    if(( oldstk = fopen( filename, "r" )) != NULL ) {
        while(( c = fgetc( oldstk )) != EOF)
            fputc( c, stkfp );
        fclose( oldstk );
        unlink( filename );
    }
    fclose( stkfp );
    if(( stat = rename( pathbuf, filename )) != 0 ) {
        puts( "PushStr: trouble renaming file." );
		return ERROR;
    }
	return OK;
}
